import java.util.*;
import java.io.*;

class WaterFlowA
{
	static long count = 0;
	
	public static void main( String[] args ) throws FileNotFoundException
	{
		// Get file name for map and starting point from command line.
		String fileName = args[0];
		int startRow = Integer.parseInt( args[1] );
		int startCol = Integer.parseInt( args[2] );
		
		// Create elevation map.
		ElevationMap map = new ElevationMap( fileName );

		Path path = new Path();

		// See if the water will flow off map		
		boolean mapWillFlow = willFlow( map, startRow, startCol, path );

		
		String msg = "Map file: " + fileName + ", Starting point: " + startRow + ", " + startCol;
		System.out.println( msg );
		msg = "Water will fall off the map? " + mapWillFlow;
		System.out.println( msg );
		
 		if( mapWillFlow ) path.print();
		
 		map.display();
	}
	
	public static boolean willFlow( ElevationMap map, int startRow, int startCol, Path path )
	{
		// You write this code, recursively
		return false;
	}	
}

// Class represents the best path to the ocean.
class Path
{
	ArrayList<Step> steps = new ArrayList<Step>();
	
	void print()
	{
		System.out.println( "Best Path" );
		
		for( Step s : steps ) System.out.print( s + ", " );
		System.out.println();
	}
}
// Class represents a step in a path
class Step
{
	int row=-1, col=-1;
	
	Step( int row, int col )
	{
		this.row = row;
		this.col = col;
	}
	
	public String toString()
	{
		return "(" + row + ", " + col + ")";	
	}
}

// Class represents a 2-d map of elevations
class ElevationMap
{
	int rows=0, cols=0;
	double[][] elevation;
	
	ElevationMap( String fileName ) throws FileNotFoundException
	{

      // Declare input file.     
		File inFile;
      
		inFile = new File( fileName );
      
      if( !inFile.exists() )
      {
         System.out.println( "Can't find file" );
         System.exit(0);
      }
      // Declare and create Scanner.
      Scanner input = new Scanner( inFile );

		this.rows = input.nextInt();
		this.cols = input.nextInt();
		
		elevation = new double[rows][cols];
		
		int curRow = 0;
		
      // While there are more things to read...
      while( input.hasNext() )
      {
			for( int i=0; i<cols; i++ )
			{
				elevation[curRow][i] = input.nextDouble();
			}
			curRow++;
      }    
		
      // Close the Scanner.
      input.close();
		
	}
	// Method to display map.
	void display()
	{
		System.out.println( "Num rows=" + rows + ", cols=" + cols );
		
		for( double[] row : elevation )
		{
			System.out.println( Arrays.toString( row ) );
		}
	}
	// Method to see if a row coordinate is off the map
	boolean isRowOffMap( int row )
	{
		if( ( row < 0 ) || ( row >= elevation.length ) )
			return true;
		return false;
	}

	// Method to see if a column coordinate is off the map
	boolean isColOffMap( int col )
	{
		if( ( col < 0 ) || ( col >= elevation[0].length ) )
			return true;
		return false;
	}
}
