// works without path stuff.
// reference: http://userweb.cs.utexas.edu/~scottm/cs307/Assignments/RecursionSummer.html


import java.util.*;
import java.io.*;

class WaterFlowTest
{
	static long count = 0;
	
	public static void main( String[] args ) throws FileNotFoundException
	{
		// Get file name for map and starting point from command line.
		String fileName = args[0];
		int startRow = Integer.parseInt( args[1] );
		int startCol = Integer.parseInt( args[2] );
		
		// Create elevation map.
		ElevationMap map = new ElevationMap( fileName );

		LinkedList<Step> path = new LinkedList<Step>();
		
		boolean mapWillFlow = willFlow( map, startRow, startCol );
// 		boolean mapWillFlow = willFlow( map, startRow, startCol, path );
		System.out.println( mapWillFlow );
		
		String msg = "Map file: " + fileName + ", Starting point: " + startRow + ", " + startCol;
		System.out.println( msg );
		msg = "Water will fall off the map? " + mapWillFlow;
		System.out.println( msg );
		
// 		if( mapWillFlow ) printPath
// 		{
// 			System.out.println( "path" );
// 		
// 			for( Step s : path ) System.out.print( s + ", " );
// 			System.out.println();
// 		}
 		map.display();
	}
	
//	public static boolean willFlow( ElevationMap map, int startRow, int startCol, Path path )
	public static boolean willFlow( ElevationMap map, int startRow, int startCol )
	{
		// You write this code
		// N, S, E, W
		int[] rows = { startRow-1, startRow+1, startRow,   startRow };
		int[] cols = { startCol,   startCol,   startCol-1, startCol+1 };

		double elev = map.elevation[startRow][startCol];
		System.out.println( "willFlow begin, elev=" + elev + " at " + startRow + ", " + startCol );
		
		for( int i=0; i<4; i++ )
		{

			System.out.println( "  in loop,i=" + i + ", considering " + rows[i] + ", " + cols[i] );
			
			if( map.isRowOffMap( rows[i] ) || map.isColOffMap( cols[i] ) )
			{
				System.out.println( "    Off map " + rows[i] + ", " + cols[i] );
				
//				path.add( new Step( startRow, startCol ) );

				return true;
			}
				
 			double adjElev = map.elevation[rows[i]][cols[i]];
			
			if( adjElev < elev )
			{
				System.out.println( "    Found lower: new elev: " + adjElev + " in " + rows[i] + ", " + cols[i] );
			
				if( willFlow( map, rows[i], cols[i] ) )
// 				if( willFlow( map, rows[i], cols[i], path ) )
				{
//					path.add( new Step( startRow, startCol ) );
					return true;
				}
				else
				{
//					path.removeLast();
				}
			}
			else
			{
				System.out.println( "  Next position" );
			}
		}
		return false;
	}	
}
// Class represents the best path to the ocean.
class Path
{
	ArrayList<Step> steps = new ArrayList<Step>();
	
	void print()
	{
		System.out.println( "Best Path" );
		
		for( Step s : steps ) System.out.print( s + ", " );
		System.out.println();
	}
}
// Class represents a step in a path
class Step
{
	int row=-1, col=-1;
	
	Step( int row, int col )
	{
		this.row = row;
		this.col = col;
	}
	
	public String toString()
	{
		return "(" + row + ", " + col + ")";	
	}
}

class ElevationMap
{
	int rows=0, cols=0;
	double[][] elevation;
	
	public ElevationMap( int rows, int cols )
	{
		this.rows = rows;
		this.cols = cols;
		elevation = new double[rows][cols];
	}
	
	ElevationMap( String fileName ) throws FileNotFoundException
	{

      // Declare input file.     
		File inFile;
      
		inFile = new File( fileName );
      
      if( !inFile.exists() )
      {
         System.out.println( "Can't find file" );
         System.exit(0);
      }
      // Declare and create Scanner.
      Scanner input = new Scanner( inFile );

		this.rows = input.nextInt();
		this.cols = input.nextInt();
		
		elevation = new double[rows][cols];
		
		int curRow = 0;
		
      // While there are more things to read...
      while( input.hasNext() )
      {
			for( int i=0; i<cols; i++ )
			{
				elevation[curRow][i] = input.nextDouble();
			}
			curRow++;
      }    
		
      // Close the Scanner.
      input.close();
		
	}
	// Method to display map.
	void display()
	{
		System.out.println( "Num rows=" + rows + ", cols=" + cols );
		
		for( double[] row : elevation )
		{
			System.out.println( Arrays.toString( row ) );
		}
	}
	// Method to see if a row coordinate is off the map
	boolean isRowOffMap( int row )
	{
		if( ( row < 0 ) || ( row >= elevation.length ) )
			return true;
		return false;
	}

	// Method to see if a column coordinate is off the map
	boolean isColOffMap( int col )
	{
		if( ( col < 0 ) || ( col >= elevation[0].length ) )
			return true;
		return false;
	}
}
